
_Main_Init:

;electronique_interface_midi_007_16f628.mpas,49 :: 		begin
;electronique_interface_midi_007_16f628.mpas,50 :: 		CMCON := 7;            // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_interface_midi_007_16f628.mpas,51 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_interface_midi_007_16f628.mpas,52 :: 		INTCON.GIE := 1;       // |- enable interrupt
	BSF        INTCON+0, 7
;electronique_interface_midi_007_16f628.mpas,53 :: 		INTCON.PEIE := 1;      // |
	BSF        INTCON+0, 6
;electronique_interface_midi_007_16f628.mpas,54 :: 		TRISA      := %11101000;
	MOVLW      232
	MOVWF      TRISA+0
;electronique_interface_midi_007_16f628.mpas,55 :: 		TRISB      := %11100010;
	MOVLW      226
	MOVWF      TRISB+0
;electronique_interface_midi_007_16f628.mpas,56 :: 		PORTA      := 0;  // clear porta
	CLRF       PORTA+0
;electronique_interface_midi_007_16f628.mpas,57 :: 		PORTB      := 0;  // clear portb
	CLRF       PORTB+0
;electronique_interface_midi_007_16f628.mpas,58 :: 		T1CON.T1CKPS1 := 1;
	BSF        T1CON+0, 5
;electronique_interface_midi_007_16f628.mpas,59 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,61 :: 		TXSTA.SYNC := 0;    // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,62 :: 		TXSTA.TX9 := 0;     // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_007_16f628.mpas,63 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_007_16f628.mpas,64 :: 		RCSTA.CREN := 1;    // enable receiving / accept continuous mode
	BSF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,65 :: 		RCSTA.SPEN := 1;    // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_interface_midi_007_16f628.mpas,66 :: 		RCSTA.RX9 := 0;     // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_interface_midi_007_16f628.mpas,67 :: 		PIE1.RCIE := 1;     // enable interrupt for UART Rx
	BSF        PIE1+0, 5
;electronique_interface_midi_007_16f628.mpas,69 :: 		UART1_Init(31250);  // speed for MIDI communication
	MOVLW      39
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_007_16f628.mpas,71 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,72 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,73 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,74 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,75 :: 		end;
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_interface_midi_007_16f628.mpas,78 :: 		begin
;electronique_interface_midi_007_16f628.mpas,79 :: 		if TestBit(PIR1, RCIF) then
	CLRF       R0+0
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt6
	MOVLW      1
	MOVWF      R0+0
L__Interrupt6:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt4
;electronique_interface_midi_007_16f628.mpas,82 :: 		RxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _RxData+0
;electronique_interface_midi_007_16f628.mpas,85 :: 		if (not (RxData = cMIDI_Active_Sensing)) then
	MOVF       _RxData+0, 0
	XORLW      254
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	COMF       R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt8
;electronique_interface_midi_007_16f628.mpas,86 :: 		bDataReceived := true;
	MOVLW      255
	MOVWF      _bDataReceived+0
L__Interrupt8:
;electronique_interface_midi_007_16f628.mpas,87 :: 		if TestBit(RCSTA, OERR) then
	CLRF       R0+0
	BTFSS      RCSTA+0, 1
	GOTO       L__Interrupt13
	MOVLW      1
	MOVWF      R0+0
L__Interrupt13:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt11
;electronique_interface_midi_007_16f628.mpas,89 :: 		ClearBit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,90 :: 		SetBit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_interface_midi_007_16f628.mpas,91 :: 		end;
L__Interrupt11:
;electronique_interface_midi_007_16f628.mpas,93 :: 		end;
L__Interrupt4:
;electronique_interface_midi_007_16f628.mpas,94 :: 		end;
L__Interrupt139:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Note_Play:

;electronique_interface_midi_007_16f628.mpas,97 :: 		begin
;electronique_interface_midi_007_16f628.mpas,98 :: 		UART1_Write(Data1);
	MOVF       FARG_Note_Play_Data1+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,99 :: 		UART1_Write(Data2);
	MOVF       FARG_Note_Play_Data2+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,100 :: 		UART1_Write(Data3);
	MOVF       FARG_Note_Play_Data3+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_007_16f628.mpas,101 :: 		end;
	RETURN
; end of _Note_Play

_Rx_Reset:

;electronique_interface_midi_007_16f628.mpas,104 :: 		begin
;electronique_interface_midi_007_16f628.mpas,105 :: 		for i := 1 to 3 do
	MOVLW      1
	MOVWF      _i+0
L__Rx_Reset17:
;electronique_interface_midi_007_16f628.mpas,106 :: 		ArrRxData[i] := $00;
	DECF       _i+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	CLRF       INDF+0
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Rx_Reset20
	INCF       _i+0, 1
	GOTO       L__Rx_Reset17
L__Rx_Reset20:
;electronique_interface_midi_007_16f628.mpas,107 :: 		end;
	RETURN
; end of _Rx_Reset

_Disp_Init:

;electronique_interface_midi_007_16f628.mpas,110 :: 		begin
;electronique_interface_midi_007_16f628.mpas,112 :: 		for i := 0 to 15 do
	CLRF       _i+0
L__Disp_Init23:
;electronique_interface_midi_007_16f628.mpas,114 :: 		for j := 0 to 7 do
	CLRF       _j+0
L__Disp_Init28:
;electronique_interface_midi_007_16f628.mpas,115 :: 		ArrOuts[i].j := 0;
	MOVF       _i+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _j+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Disp_Init140:
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init141
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Disp_Init140
L__Disp_Init141:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       _j+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init31
	INCF       _j+0, 1
	GOTO       L__Disp_Init28
L__Disp_Init31:
;electronique_interface_midi_007_16f628.mpas,116 :: 		end;
	MOVF       _i+0, 0
	XORLW      15
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Init26
	INCF       _i+0, 1
	GOTO       L__Disp_Init23
L__Disp_Init26:
;electronique_interface_midi_007_16f628.mpas,117 :: 		end;
	RETURN
; end of _Disp_Init

_Out_Refresh:

;electronique_interface_midi_007_16f628.mpas,123 :: 		begin
;electronique_interface_midi_007_16f628.mpas,130 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,132 :: 		Out_Clock := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,134 :: 		Out_Strobe := 0;
	BCF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,136 :: 		for iOutGroup := 15 downto 0 do
	MOVLW      15
	MOVWF      _iOutGroup+0
L__Out_Refresh36:
;electronique_interface_midi_007_16f628.mpas,138 :: 		for iOutBit := 7 downto 0 do
	MOVLW      7
	MOVWF      _iOutBit+0
L__Out_Refresh41:
;electronique_interface_midi_007_16f628.mpas,140 :: 		Out_Data := ArrOuts[iOutGroup].iOutBit;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      FSR
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Out_Refresh142:
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh143
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Out_Refresh142
L__Out_Refresh143:
	MOVF       R0+0, 0
	ANDWF      INDF+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh45
	MOVLW      1
	MOVWF      R1+0
L__Out_Refresh45:
	BTFSC      R1+0, 0
	GOTO       L__Out_Refresh144
	BCF        RA0_bit+0, 0
	GOTO       L__Out_Refresh145
L__Out_Refresh144:
	BSF        RA0_bit+0, 0
L__Out_Refresh145:
;electronique_interface_midi_007_16f628.mpas,141 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,142 :: 		Out_Clock := 1;   // clock high
	BSF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,143 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,144 :: 		Out_Clock := 0; // clock low
	BCF        RA1_bit+0, 1
;electronique_interface_midi_007_16f628.mpas,145 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,146 :: 		end;
	MOVF       _iOutBit+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh44
	DECF       _iOutBit+0, 1
	GOTO       L__Out_Refresh41
L__Out_Refresh44:
;electronique_interface_midi_007_16f628.mpas,147 :: 		end;
	MOVF       _iOutGroup+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Out_Refresh39
	DECF       _iOutGroup+0, 1
	GOTO       L__Out_Refresh36
L__Out_Refresh39:
;electronique_interface_midi_007_16f628.mpas,149 :: 		Out_Strobe := 1;
	BSF        RA2_bit+0, 2
;electronique_interface_midi_007_16f628.mpas,151 :: 		Out_Data := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_007_16f628.mpas,152 :: 		Delay_us(iDelayData);
	NOP
	NOP
	NOP
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,153 :: 		end;
	RETURN
; end of _Out_Refresh

_Main_Welcome:

;electronique_interface_midi_007_16f628.mpas,156 :: 		begin
;electronique_interface_midi_007_16f628.mpas,157 :: 		Note_Play(cMIDI_Note_On, cMIDI_Pitch_base, cMIDI_Vel_On);
	MOVLW      144
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	MOVLW      100
	MOVWF      FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_007_16f628.mpas,158 :: 		Delay_ms(100);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__Main_Welcome47:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome47
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome47
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome47
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,159 :: 		Note_Play(cMIDI_Note_Off, cMIDI_Pitch_base, cMIDI_Vel_Off);
	MOVLW      128
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	CLRF       FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_007_16f628.mpas,160 :: 		Delay_ms(30);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L__Main_Welcome48:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome48
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome48
;electronique_interface_midi_007_16f628.mpas,161 :: 		end;
	RETURN
; end of _Main_Welcome

_main:

;electronique_interface_midi_007_16f628.mpas,164 :: 		begin
;electronique_interface_midi_007_16f628.mpas,165 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_007_16f628.mpas,166 :: 		bRxEcho := In_RxEcho;
	MOVLW      0
	BTFSC      RA3_bit+0, 3
	MOVLW      1
	MOVWF      _bRxEcho+0
;electronique_interface_midi_007_16f628.mpas,167 :: 		bModePulse := In_Mode;      // RB7=1 > selected out play as pulse
	MOVLW      0
	BTFSC      RB7_bit+0, 7
	MOVLW      1
	MOVWF      _bModePulse+0
;electronique_interface_midi_007_16f628.mpas,170 :: 		Disp_Init;
	CALL       _Disp_Init+0
;electronique_interface_midi_007_16f628.mpas,173 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_interface_midi_007_16f628.mpas,176 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_007_16f628.mpas,177 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,179 :: 		while true do
L__main51:
;electronique_interface_midi_007_16f628.mpas,182 :: 		if bDataReceived then
	MOVF       _bDataReceived+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main56
;electronique_interface_midi_007_16f628.mpas,184 :: 		bDataReceived := false;
	CLRF       _bDataReceived+0
;electronique_interface_midi_007_16f628.mpas,187 :: 		if bRxEcho then
	MOVF       _bRxEcho+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main59
;electronique_interface_midi_007_16f628.mpas,188 :: 		UART1_Write(RxData);
	MOVF       _RxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
L__main59:
;electronique_interface_midi_007_16f628.mpas,191 :: 		if ((rxData = cMIDI_Note_On) or (rxData = cMIDI_Note_Off)) then
	MOVF       _RxData+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _RxData+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main62
;electronique_interface_midi_007_16f628.mpas,193 :: 		iRxByteCount := 1;
	MOVLW      1
	MOVWF      _iRxByteCount+0
;electronique_interface_midi_007_16f628.mpas,194 :: 		ArrRxData[iRxByteCount] := RxData;
	CLRF       R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       _RxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,195 :: 		end
	GOTO       L__main63
;electronique_interface_midi_007_16f628.mpas,196 :: 		else
L__main62:
;electronique_interface_midi_007_16f628.mpas,198 :: 		inc(iRxByteCount);
	INCF       _iRxByteCount+0, 1
;electronique_interface_midi_007_16f628.mpas,199 :: 		ArrRxData[iRxByteCount] := RxData;
	DECF       _iRxByteCount+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       _RxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,202 :: 		if iRxByteCount >= 3 then
	MOVLW      3
	SUBWF      _iRxByteCount+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__main65
;electronique_interface_midi_007_16f628.mpas,206 :: 		bNoteOn := ((ArrRxData[1] = cMIDI_Note_On) and (ArrRxData[3] > $00));
	MOVF       _ArrRxData+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+2, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      _bNoteOn+0
;electronique_interface_midi_007_16f628.mpas,209 :: 		((ArrRxData[1] = cMIDI_Note_On) and (ArrRxData[3] = $00)) or
	MOVF       _ArrRxData+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+2, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
;electronique_interface_midi_007_16f628.mpas,210 :: 		(ArrRxData[1] = cMIDI_Note_Off));
	MOVF       _ArrRxData+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bNoteOff+0
;electronique_interface_midi_007_16f628.mpas,213 :: 		if (bNoteOn or bNoteOff) then
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main68
;electronique_interface_midi_007_16f628.mpas,217 :: 		if ((ArrRxData[2] >= 0) and (ArrRxData[2] <= 7)) then
	MOVLW      0
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      7
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main71
;electronique_interface_midi_007_16f628.mpas,219 :: 		iOutGroup := 0;
	CLRF       _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,220 :: 		iOutBit := ArrRxData[2];
	MOVF       _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,221 :: 		end
	GOTO       L__main72
;electronique_interface_midi_007_16f628.mpas,222 :: 		else if ((ArrRxData[2] >= 8) and (ArrRxData[2] <= 15)) then
L__main71:
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      15
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main74
;electronique_interface_midi_007_16f628.mpas,224 :: 		iOutGroup := 1;
	MOVLW      1
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,225 :: 		iOutBit := ArrRxData[2] - 8;
	MOVLW      8
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,226 :: 		end
	GOTO       L__main75
;electronique_interface_midi_007_16f628.mpas,227 :: 		else if ((ArrRxData[2] >= 16) and (ArrRxData[2] <= 23)) then
L__main74:
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      23
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main77
;electronique_interface_midi_007_16f628.mpas,229 :: 		iOutGroup := 2;
	MOVLW      2
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,230 :: 		iOutBit := ArrRxData[2] - 16;
	MOVLW      16
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,231 :: 		end
	GOTO       L__main78
;electronique_interface_midi_007_16f628.mpas,232 :: 		else if ((ArrRxData[2] >= 24) and (ArrRxData[2] <= 31)) then
L__main77:
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      31
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main80
;electronique_interface_midi_007_16f628.mpas,234 :: 		iOutGroup := 3;
	MOVLW      3
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,235 :: 		iOutBit := ArrRxData[2] - 24;
	MOVLW      24
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,236 :: 		end
	GOTO       L__main81
;electronique_interface_midi_007_16f628.mpas,237 :: 		else if ((ArrRxData[2] >= 32) and (ArrRxData[2] <= 39)) then
L__main80:
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      39
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main83
;electronique_interface_midi_007_16f628.mpas,239 :: 		iOutGroup := 4;
	MOVLW      4
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,240 :: 		iOutBit := ArrRxData[2] - 32;
	MOVLW      32
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,241 :: 		end
	GOTO       L__main84
;electronique_interface_midi_007_16f628.mpas,242 :: 		else if ((ArrRxData[2] >= 40) and (ArrRxData[2] <= 47)) then
L__main83:
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      47
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main86
;electronique_interface_midi_007_16f628.mpas,244 :: 		iOutGroup := 5;
	MOVLW      5
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,245 :: 		iOutBit := ArrRxData[2] - 40;
	MOVLW      40
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,246 :: 		end
	GOTO       L__main87
;electronique_interface_midi_007_16f628.mpas,247 :: 		else if ((ArrRxData[2] >= 48) and (ArrRxData[2] <= 55)) then
L__main86:
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      55
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main89
;electronique_interface_midi_007_16f628.mpas,249 :: 		iOutGroup := 6;
	MOVLW      6
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,250 :: 		iOutBit := ArrRxData[2] - 48;
	MOVLW      48
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,251 :: 		end
	GOTO       L__main90
;electronique_interface_midi_007_16f628.mpas,252 :: 		else if ((ArrRxData[2] >= 56) and (ArrRxData[2] <= 63)) then
L__main89:
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      63
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main92
;electronique_interface_midi_007_16f628.mpas,254 :: 		iOutGroup := 7;
	MOVLW      7
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,255 :: 		iOutBit := ArrRxData[2] - 56;
	MOVLW      56
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,256 :: 		end
	GOTO       L__main93
;electronique_interface_midi_007_16f628.mpas,257 :: 		else if ((ArrRxData[2] >= 64) and (ArrRxData[2] <= 71)) then
L__main92:
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      71
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main95
;electronique_interface_midi_007_16f628.mpas,259 :: 		iOutGroup := 8;
	MOVLW      8
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,260 :: 		iOutBit := ArrRxData[2] - 64;
	MOVLW      64
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,261 :: 		end
	GOTO       L__main96
;electronique_interface_midi_007_16f628.mpas,262 :: 		else if ((ArrRxData[2] >= 72) and (ArrRxData[2] <= 79)) then
L__main95:
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      79
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main98
;electronique_interface_midi_007_16f628.mpas,264 :: 		iOutGroup := 9;
	MOVLW      9
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,265 :: 		iOutBit := ArrRxData[2] - 72;
	MOVLW      72
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,266 :: 		end
	GOTO       L__main99
;electronique_interface_midi_007_16f628.mpas,267 :: 		else if ((ArrRxData[2] >= 80) and (ArrRxData[2] <= 87)) then
L__main98:
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      87
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main101
;electronique_interface_midi_007_16f628.mpas,269 :: 		iOutGroup := 10;
	MOVLW      10
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,270 :: 		iOutBit := ArrRxData[2] - 80;
	MOVLW      80
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,271 :: 		end
	GOTO       L__main102
;electronique_interface_midi_007_16f628.mpas,272 :: 		else if ((ArrRxData[2] >= 88) and (ArrRxData[2] <= 95)) then
L__main101:
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      95
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main104
;electronique_interface_midi_007_16f628.mpas,274 :: 		iOutGroup := 11;
	MOVLW      11
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,275 :: 		iOutBit := ArrRxData[2] - 88;
	MOVLW      88
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,276 :: 		end
	GOTO       L__main105
;electronique_interface_midi_007_16f628.mpas,277 :: 		else if ((ArrRxData[2] >= 96) and (ArrRxData[2] <= 103)) then
L__main104:
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      103
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main107
;electronique_interface_midi_007_16f628.mpas,279 :: 		iOutGroup := 12;
	MOVLW      12
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,280 :: 		iOutBit := ArrRxData[2] - 96;
	MOVLW      96
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,281 :: 		end
	GOTO       L__main108
;electronique_interface_midi_007_16f628.mpas,282 :: 		else if ((ArrRxData[2] >= 104) and (ArrRxData[2] <= 111)) then
L__main107:
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      111
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main110
;electronique_interface_midi_007_16f628.mpas,284 :: 		iOutGroup := 13;
	MOVLW      13
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,285 :: 		iOutBit := ArrRxData[2] - 104;
	MOVLW      104
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,286 :: 		end
	GOTO       L__main111
;electronique_interface_midi_007_16f628.mpas,287 :: 		else if ((ArrRxData[2] >= 112) and (ArrRxData[2] <= 119)) then
L__main110:
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      119
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main113
;electronique_interface_midi_007_16f628.mpas,289 :: 		iOutGroup := 14;
	MOVLW      14
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,290 :: 		iOutBit := ArrRxData[2] - 112;
	MOVLW      112
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,291 :: 		end
	GOTO       L__main114
;electronique_interface_midi_007_16f628.mpas,292 :: 		else if ((ArrRxData[2] >= 120) and (ArrRxData[2] <= 127)) then
L__main113:
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _ArrRxData+1, 0
	SUBLW      127
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main116
;electronique_interface_midi_007_16f628.mpas,294 :: 		iOutGroup := 15;
	MOVLW      15
	MOVWF      _iOutGroup+0
;electronique_interface_midi_007_16f628.mpas,295 :: 		iOutBit := ArrRxData[2] - 120;
	MOVLW      120
	SUBWF      _ArrRxData+1, 0
	MOVWF      _iOutBit+0
;electronique_interface_midi_007_16f628.mpas,296 :: 		end;
L__main116:
L__main114:
L__main111:
L__main108:
L__main105:
L__main102:
L__main99:
L__main96:
L__main93:
L__main90:
L__main87:
L__main84:
L__main81:
L__main78:
L__main75:
L__main72:
;electronique_interface_midi_007_16f628.mpas,299 :: 		if bModePulse then
	MOVF       _bModePulse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main119
;electronique_interface_midi_007_16f628.mpas,302 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main122
;electronique_interface_midi_007_16f628.mpas,305 :: 		ArrOuts[iOutGroup].iOutBit := 1;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main146:
	BTFSC      STATUS+0, 2
	GOTO       L__main147
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main146
L__main147:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,307 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,309 :: 		Delay_ms(100); // or Delay_ms(10) for example
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L__main126:
	DECFSZ     R13+0, 1
	GOTO       L__main126
	DECFSZ     R12+0, 1
	GOTO       L__main126
	DECFSZ     R11+0, 1
	GOTO       L__main126
	NOP
	NOP
;electronique_interface_midi_007_16f628.mpas,311 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main148:
	BTFSC      STATUS+0, 2
	GOTO       L__main149
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main148
L__main149:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_007_16f628.mpas,313 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,314 :: 		end;
L__main122:
;electronique_interface_midi_007_16f628.mpas,315 :: 		end
	GOTO       L__main120
;electronique_interface_midi_007_16f628.mpas,316 :: 		else
L__main119:
;electronique_interface_midi_007_16f628.mpas,321 :: 		if bNoteOn then
	MOVF       _bNoteOn+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main130
;electronique_interface_midi_007_16f628.mpas,322 :: 		ArrOuts[iOutGroup].iOutBit := 1
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main150:
	BTFSC      STATUS+0, 2
	GOTO       L__main151
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main150
L__main151:
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	GOTO       L__main131
;electronique_interface_midi_007_16f628.mpas,323 :: 		else if bNoteOff then
L__main130:
	MOVF       _bNoteOff+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main135
;electronique_interface_midi_007_16f628.mpas,324 :: 		ArrOuts[iOutGroup].iOutBit := 0;
	MOVF       _iOutGroup+0, 0
	ADDLW      _ArrOuts+0
	MOVWF      R2+0
	MOVF       _iOutBit+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__main152:
	BTFSC      STATUS+0, 2
	GOTO       L__main153
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main152
L__main153:
	COMF       R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	ANDWF      R0+0, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
L__main135:
L__main131:
;electronique_interface_midi_007_16f628.mpas,326 :: 		Out_Refresh;
	CALL       _Out_Refresh+0
;electronique_interface_midi_007_16f628.mpas,327 :: 		end;
L__main120:
;electronique_interface_midi_007_16f628.mpas,329 :: 		end;
L__main68:
;electronique_interface_midi_007_16f628.mpas,331 :: 		end;
L__main65:
;electronique_interface_midi_007_16f628.mpas,332 :: 		end;
L__main63:
;electronique_interface_midi_007_16f628.mpas,333 :: 		end;
L__main56:
;electronique_interface_midi_007_16f628.mpas,336 :: 		end;
	GOTO       L__main51
;electronique_interface_midi_007_16f628.mpas,338 :: 		end.
	GOTO       $+0
; end of _main
